version: '3.5'

services:
    ### Grafana  ################################################
    grafana:
        build:
            context: ./grafana
        volumes:
            - ${DATA_PATH_HOST}:/var/lib/grafana
        ports:
            - "3001:3000"
          # - ${GRAFANA_PORT}:3000

    ### InfluxDB ################################################
    influxdb:
        image: influxdb:2.0.7
        volumes:
            # Mount for influxdb data directory and configuration
            - ./influxdb/temp/influxdbv2:/var/lib/influxdbv2:rw
        ports:
            - "8086:8068"

    # Use the influx cli set up an influxdb instance.
    influxdb_cli:
        links:
            - influxdb
        image: influxdb:2.0.7
        volumes:
            # Mount for influxdb data directory and configuration
            -  ./influxdb/temp/influxdbv2:/var/lib/influxdb2:rw
            -  ./influxdb/ssl/influxdb-selfsigned.crt:/etc/ssl/influxdb-selfsigned.crt:rw
            -  ./influxdb/ssl/influxdb-selfsigned.key:/etc/ssl/influxdb-selfsigned.key:rw
        environment:
            # Use the same configurations parameters in your telegraf configuration, mytelegraf.conf.
            - DOCKER_INFLUXDB_INIT_MODE=setup
            - DOCKER_INFLUXDB_INIT_USERNAME=myusername
            - DOCKER_INFLUXDB_INIT_PASSWORD=passwordpasswordpassword
            - DOCKER_INFLUXDB_INIT_ORG=myorg
            - DOCKER_INFLUXDB_INIT_BUCKET=mytoken
            - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=mytoken
            - INFLUXDB_TLS_CERT=/etc/ssl/influxdb-selfsigned.crt
            - INFLUXDB_TLS_KETY=/etc/ssl/influxdb-selfsigned.key
        entrypoint: ["./entrypoint.sh"]
        restart: on-failure:10
        depends_on:
            -   influxdb

    telegraf:
        image: telegraf
        links:
            - influxdb
        volumes:
            # Mount for telegraf config
            - ./telegraf/mytelegraf.conf:/etc/telegraf/telegraf.conf
        env_file:
            - ./influxv2.env
        environment:
            - DOCKER_INFLUXDB_INIT_ORG=myorg
            - DOCKER_INFLUXDB_INIT_BUCKET=mybucket
            - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=mytoken
        depends_on:
            -   influxdb_cli

networks:
    monitoring:

volumes:
    grafana-volume:
        external: true
    influx
    influxdbv2: